'use strict';

const {
  dialogflow,
  SimpleResponse,
  BasicCard,
  Button,
  Image,
  BrowseCarousel,
  BrowseCarouselItem,
  Suggestions,
  LinkOutSuggestion,
  MediaObject,
  Table,
  List,
  Carousel,
} = require('actions-on-google');
const functions = require('firebase-functions');

const app = dialogflow({debug: true});

//variables horas
const timeZone = 'CEST CENTRAL EUROPE SUMMER TIME';
const timeZoneOffset = '+02:00';

//Parámetros firebase
const admin = require('firebase-admin');
admin.initializeApp(functions.config().firebase);
const db = admin.firestore();
const settings = {/* your settings... */ timestampsInSnapshots: true};
db.settings(settings);


//parámetros log in
var login = `No`;
const parameters = { // Custom parameters to pass with context
     login: true,
};
//parámetros música
var musicaIteraciones = 0;
var musica = [0,1,2,3];
//parámetros chistes
var chiste = [1,2,3,4,5,6];
var chisIteraciones =0;


// start default welcome
app.intent('bienvenida.inicio(1.0)', (conv) => {
    
 	 conv.ask(saludo(conv));
     conv.ask(`¿Cómo te llamas?`);

});
// end default welcome

// start login
app.intent('bienvenida.login(1.0)', (conv, {name}) => {
  
   var numero = name.length;
   var nombre = String(name[0]) ;
  if (numero>0)
  {
    for(var i=1; i<numero; i++)
        {
      	  	nombre = nombre + ` ` + name[i];
    	}
  }
   conv.data.nombre = nombre;
   login =`Si`;
   conv.ask(`Hola ` + conv.data.nombre);   
    const dialogflowNameDoc = db.collection('dialogflow').doc(conv.data.nombre);
   return dialogflowNameDoc.get()
      .then(doc => {
        if (!doc.exists) {
          conv.ask(`No encuentro tu nombre en la base de datos, si quieres puedo registrarte` + 
           `, para eso dime solo tu apellido, o si lo prefieres dime que no quieres registrarte.`);
          conv.contexts.set('newUser', 2, parameters);
        } 
     
   else {
     		conv.data.apellido = doc.data().apellido;
     		conv.data.lastSeen = doc.data().lastSeen;
       		conv.data.vecesHoy = doc.data().vecesHoy;
     		conv.data.fechas = doc.data().fechas;
        	conv.data.personas  = doc.data().personas;
     		conv.data.cantante = doc.data().cantante;
     		conv.data.visitas = doc.data().visitas ;
       		conv.ask(`¿Entonces te llamas ` + conv.data.nombre +` `+doc.data().apellido + `?`);
            conv.contexts.set('login', 2, parameters);
        }  
      return Promise.resolve('Read complete');
      }).catch(() => {
        conv.ask(`Error consultando la entrada, por favor inténtalo mas tarde`);

      });

});

// end login

//start signin
app.intent('bienvenida.login.signin(1.0)', (conv, {apellido}) => {
  
   var numero = apellido.length;
   var apellidos = String(apellido[0]) ;
  if (numero>0)
  {
    for(var i=1; i<numero; i++)
        {
      	  	apellidos = apellidos + ` ` + apellido[i];
    	}
  }
  conv.data.apellido = apellidos;
  login =`Si`;
  
   conv.ask(`Perfecto, recordaré que te llamas ` + conv.data.nombre + ` `+ conv.data.apellido +
            `. \n Como es la primera vez que nos vemos te contaré qué cosas puedo hacer.`+
           `\n ¡Puedo contarte un chiste, poner música, jugar a juegos, contarte adivinanzas`+
            `, mostrarte tus medicinas e incluso ayudarte a pedir cita para el médico!`+
           `También podemos hacer ejercicio y recordar cosas como tu cumpleaños o tu cantante favorito`);
    const dialogflowAgentRef = db.collection('dialogflow').doc(conv.data.nombre);
    return db.runTransaction(t => {
      t.set(dialogflowAgentRef, {
        apellido: conv.data.apellido,
        visitas : 1,
        vecesHoy : 0,
        fechas : ` `,
        personas : ` `,
        cantante : ` `,
        lastSeen : fecha(new Date())
      });
      return Promise.resolve('Write complete');
    });
 
});

//// end signin

// start newName
app.intent('bienvenida.login.newname(1.0)', (conv, {name}) => {
  
   
   var numero = name.length;
   var nombre = String(name[0]) ;
  if (numero>0)
  {
    for(var i=1; i<numero; i++)
        {
      	  	nombre = nombre + ` ` + name[i];
    	}
  }
  conv.data.nombre = nombre;
  login=`Si`;
    //obtiene la lista de nombres de la base de datos
    const dialogflowNameDoc = db.collection('dialogflow').doc(conv.data.nombre);
   return dialogflowNameDoc.get()
      .then(doc => {
        if (!doc.exists) {
          conv.ask(`Perfecto,  ` + conv.data.nombre +
                  `, también necesitaré tu apellido si quieres que te registre, si no es así dímelo.`);
          conv.contexts.set('newUser', 1, parameters);
        } else {
       		conv.ask(`Lo siento ` + conv.data.nombre + ` ya está cogido, elige otro nombre.`);
            conv.contexts.set('newName', 2, parameters);
        }  return Promise.resolve('Read complete');
      }).catch(() => {
        conv.ask(`Error reading entry from the Firestore database.`);
        conv.ask(`Please add a entry to the database first by saying, "Write <your phrase> to the database"`);

      });


});
// end newName

// start loginyes
app.intent('bienvenida.login(1.0) - yes', (conv) => {
  
  login =`Si`;

  //primero se comprueban los cumpleaños guardados
	var cumple = 0;
  	var mensaje =``;
	var arrayPersonas =conv.data.personas.split(`@`);
  	var arrayFechas =conv.data.fechas.split(`@`);
  if(arrayPersonas.length == arrayFechas.length)
  {
  		for (var i = 0; i < arrayPersonas.length; i++)
        {
          if (arrayFechas[i] == (` ` + fechaCumple(new Date())))
          	{
                if (arrayPersonas[i] == ` usuario`) 
                {
                  conv.ask('<speak>'+
                           '¡Hoy es tu cumpleaños, '+ conv.data.nombre+'!'+
                           '<audio src="https://actions.google.com/sounds/v1/cartoon/pop.ogg"></audio> '+
                           'Muchas felicidades.'+
                           '</speak>');
                  cumple = 1;
                }
              	else
                {
                    if (cumple == 1) mensaje= `También es el cumpleaños de`+arrayPersonas[i]+ `. Que no se te olvide.  \n`;
                  	else mensaje= `Hoy es el cumpleaños de`+arrayPersonas[i]+ `. Que no se te olvide.  \n`;
                  cumple = 1;
                
                }
       		 }
        }

  }
  //después saluda al usuario dependiendo las veces que haya venido hoy, y se actualiza dicho dato.
  	if (conv.data.lastSeen == fecha(new Date())){
            conv.data.vecesHoy = conv.data.vecesHoy +1;
            }
 	else conv.data.vecesHoy = 0;
  //dependiendo de las veces que haya visitado el chat, se le recibe de una manera diferente.
    conv.ask(mensaje + bienvenidaMemoria(conv.data.visitas , conv.data.vecesHoy , conv.data.nombre));
  
  	if (conv.data.visitas == 6) conv.contexts.set('encuesta', 2, parameters);
  //se actualiza la base de datos.
    
    const dialogflowAgentRef = db.collection('dialogflow').doc(conv.data.nombre);
    return db.runTransaction(t => {
      t.set(dialogflowAgentRef, {
        apellido: conv.data.apellido,
        visitas : conv.data.visitas + 1,
        vecesHoy : conv.data.vecesHoy,
        fechas : conv.data.fechas,
        personas : conv.data.personas,
        cantante : conv.data.cantante,
        lastSeen : fecha(new Date())
    });
      return Promise.resolve('Write complete');
    });
  
    
});

// end login yes

// start encuesta
app.intent('encuesta.nota(1.0)', (conv, {puntuacion}) => {
   if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se hacer. Tienes que registrarte primero`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {
    	
  	if (puntuacion > 5 || puntuacion < 1) {
            conv.ask(`Necesito un número del uno al cinco`);
           conv.contexts.set('respuestaEncuesta',4, parameters);
            }
 	else {
	conv.ask(`¡Muchas gracias por colaborar!`);
    const dialogflowAgentRef = db.collection('encuesta').doc(conv.data.nombre);
    return db.runTransaction(t => {
      t.set(dialogflowAgentRef, {
        puntuación: puntuacion
    });
      return Promise.resolve('Write complete');
    });
    }
  }
    
});

// end encuesta

//start cumple usuario recordar
app.intent('cumple.usuario.recordar(1.0)', (conv, {cumple}) => {
  
  if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se hacer. Tienes que registrarte primero`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {
    
  var nuevo = 1;
  var mensaje;
  var arrayPersonas =conv.data.personas.split(`@`);
  var arrayFechas =conv.data.fechas.split(`@`);
  
  if(arrayPersonas.length == arrayFechas.length)
  {
  		for (var i = 0; i < arrayPersonas.length; i++)
        {
                if (arrayPersonas[i] == ` usuario`) 
                {
					nuevo=0;
                  	arrayFechas[i] =` `+ fechaCumple(new Date(cumple));
                }
        }
	 conv.data.fechas = arrayFechas.join(`@`);
  }
  else conv.ask(`Ha ocurrido un error, inténtalo mas tarde.`);
  if (nuevo==1) {

  conv.data.fechas = conv.data.fechas + fechaCumple(new Date(cumple))+`@ `;
  conv.data.personas = conv.data.personas + `usuario@ ` ;
  }
  conv.ask(`Perfecto, recordaré el `+ fechaCumple(new Date(cumple)) + `. También puedo guardar el de otras personas y avisarte cuando lo sea.`);
    
   const dialogflowAgentRef = db.collection('dialogflow').doc(conv.data.nombre);
    return db.runTransaction(t => {
      t.set(dialogflowAgentRef, {
        apellido: conv.data.apellido,
        visitas : conv.data.visitas ,
        vecesHoy : conv.data.vecesHoy,
        fechas : conv.data.fechas,
        personas : conv.data.personas,
        cantante : conv.data.cantante,
        lastSeen : fecha(new Date())
    });
      return Promise.resolve('Write complete');
    });
  }
   
});
//end cumple usuario recordar

//start cumple usuario devolver

app.intent('cumple.usuario.devolver(1.0)', (conv) => {
  
    if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se. Tienes que registrarte primero`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {
	var cumple = 0;
	var arrayPersonas =conv.data.personas.split(`@`);
  	var arrayFechas =conv.data.fechas.split(`@`);
  if(arrayPersonas.length == arrayFechas.length)
  {
  		for (var i = 0; i < arrayPersonas.length; i++)
        {
        	if (arrayPersonas[i] == ` usuario`) 
            {
            	conv.ask(`Si mal no recuerdo, tu cumpleaños es el`+arrayFechas[i]+ `, `+conv.data.nombre);
              cumple = 1;
              conv.ask(new Suggestions(['recuerda mi cumpleaños']));
            }
          	
        }
    if (cumple == 0)
            {
            	conv.ask(`No sé tu cumpleaños `+conv.data.nombre + `. Puedes hacer que lo recuerde diciendo 'acuérdate de mi cumpleaños'`);
              	conv.ask(new Suggestions(['recuerda mi cumpleaños']));
            } 
  }
  else conv.ask(`Ha habido un error con la base de datos`);
  }
  
});
//end cumple usuario devolver
//start cumple otro devolver

app.intent('cumple.otro.devolver(1.0)', (conv, {nombre}) => {
  
   if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se hacer. Tienes que registrarte primero`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {
	var cumple = 0;
	var arrayPersonas =conv.data.personas.split(`@`);
  	var arrayFechas =conv.data.fechas.split(`@`);
  if(arrayPersonas.length == arrayFechas.length)
  {
  		for (var i = 0; i < arrayPersonas.length; i++)
        {
        	if (arrayPersonas[i] == (` `+nombre)) 
            {
            	conv.ask(`Si mal no recuerdo, su cumpleaños es el`+arrayFechas[i]+ `.`);
              cumple = 1;
              conv.ask(new Suggestions(['recuerda mi cumpleaños']));
            }
          	
        }
    if (cumple == 0)
            {
            	conv.ask(`No sé el cumpleaños de `+ nombre + `. Puedes hacer que lo recuerde diciendo 'acuérdate de un cumpleaños'`);
              	conv.ask(new Suggestions(['recuerda un cumpleaños']));
            } 
  }
  else conv.ask(`Ha habido un error con la base de datos`);
  }
  
});
//end cumple otro devolver
//start cumple usuario recordar
app.intent('cumple.otro.recordar(1.0)', (conv, {nombre , cumple}) => {
   if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se hacer. Tienes que registrarte primero`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {

  conv.data.fechas = conv.data.fechas + fechaCumple(new Date(cumple))+`@ `;
  conv.data.personas = conv.data.personas + nombre + `@ ` ;
  conv.ask(`Perfecto, recordaré que el `+ fechaCumple(new Date(cumple)) + ` es el cumpleaños de ` +nombre);
    
   const dialogflowAgentRef = db.collection('dialogflow').doc(conv.data.nombre);
    return db.runTransaction(t => {
      t.set(dialogflowAgentRef, {
        apellido: conv.data.apellido,
        visitas : conv.data.visitas ,
        vecesHoy : conv.data.vecesHoy,
        fechas : conv.data.fechas,
        personas : conv.data.personas,
        cantante : conv.data.cantante,
        lastSeen : fecha(new Date())
    });
      return Promise.resolve('Write complete');
    });
  }
});
//end cumple usuario recordar
// start cantante favorito
app.intent('musica.cantante.favorito(1.0)', (conv, {cantante}) => {
  
   if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se hacer. Tienes que registrarte primero`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {
  conv.data.cantante = cantante;
  conv.ask(`Vale `+ conv.data.nombre + `. Me acordaré de que `+conv.data.cantante+` es tu cantante favorito.` +
          
          `Te pondré canciones suyas cuando me lo pidas.`);
    
   const dialogflowAgentRef = db.collection('dialogflow').doc(conv.data.nombre);
    return db.runTransaction(t => {
      t.set(dialogflowAgentRef, {
        apellido: conv.data.apellido,
        visitas : conv.data.visitas ,
        vecesHoy : conv.data.vecesHoy,
        fechas : conv.data.fechas,
        personas : conv.data.personas,
        cantante : conv.data.cantante,
        lastSeen : fecha(new Date())
    });
      return Promise.resolve('Write complete');
    });
  }
});

// end cantantefavorito
app.intent('musica.busqueda.cantante(1.0)', (conv) => {
    if (!conv.screen
      || !conv.surface.capabilities.has('actions.capability.WEB_BROWSER')) {
    conv.ask('Lo siento, prueba ésto en un dispositivo móvil ' +
             'o en un simulador en el navegador.');
    conv.ask('¿Qué te gustaría ver ahora?');
    return;
  }

  if (conv.data.cantante != ` `)
  {
conv.ask(`Mira estas canciones`);
  conv.ask(new BasicCard({
    text: `Aquí tienes los resultados de buscar a ` + conv.data.cantante + ` en Youtube`,
    subtitle: 'Haz click en el botón de abajo',
    title: 'Búsqueda',
    buttons: new Button({
      title: 'Buscar',
      url: 'https://www.youtube.com/results?search_query=' + conv.data.cantante ,
    }),
  }));
  }
  else
  {
    conv.ask(`Aún no se quien es tu cantante favorito` + conv.data.nombre +`.` +
               `Puedes hacer que lo recuerde diciendo: "recuerda a mi cantante favorito"`);
  }
    
});    
app.intent('musica.busca(1.0)', (conv, {cantante}) => {
    if (!conv.screen
      || !conv.surface.capabilities.has('actions.capability.WEB_BROWSER')) {
    conv.ask('Lo siento, prueba ésto en un dispositivo móvil ' +
             'o en un simulador en el navegador.');
    conv.ask('¿Qué te gustaría ver ahora?');
    return;
  }

  if (conv.data.cantante != ` `)
  {
conv.ask(`Mira estas canciones`);
  conv.ask(new BasicCard({
    text: `Aquí tienes los resultados de buscar a ` + cantante + ` en Youtube`,
    subtitle: 'Haz click en el botón de abajo',
    title: 'Búsqueda',
    buttons: new Button({
      title: 'Buscar',
      url: 'https://www.youtube.com/results?search_query=' + cantante ,
    }),
  }));
  }
  else
  {
    conv.ask(`No he podido buscar a ` + cantante);
  }
    
});
//start buscar en google
app.intent('busqueda.google(1.0)', (conv, {busqueda}) => {
    if (!conv.screen
      || !conv.surface.capabilities.has('actions.capability.WEB_BROWSER')) {
    conv.ask('Lo siento, prueba ésto en un dispositivo móvil ' +
             'o en un simulador en el navegador.');
    conv.ask('¿Qué te gustaría ver ahora?');
    return;
  }

conv.ask(`Este es el resultado`);
  conv.ask(new BasicCard({
    text: `Aquí tienes los resultados de buscar ` + busqueda + ` en Google`, // Note the two spaces before '\n' required for
                                 // a line break to be rendered in the card.
    subtitle: 'Haz click en el botón de abajo',
    title: 'Búsqueda',
    buttons: new Button({
      title: 'Buscar',
      url: 'https://www.google.com/search?q=' + busqueda + '&lr=lang_es',
    }),
  }));
    
});    
//end buscar en google
//start buscar en wikipedia
app.intent('busqueda.wikipedia(1.0)', (conv, {busqueda}) => {
  if (!conv.screen
      || !conv.surface.capabilities.has('actions.capability.WEB_BROWSER')) {
    conv.ask('Lo siento, prueba ésto en un dispositivo móvil ' +
             'o en un simulador en el navegador.');
    conv.ask('¿Qué te gustaría ver ahora?');
    return;
  }

conv.ask(`Este es el resultado`);
  conv.ask(new BasicCard({
    text: `Aquí tienes los resultados de buscar ` + busqueda + ` en Wikipedia`,
    subtitle: 'Haz click en el botón de abajo',
    title: 'Búsqueda',
    buttons: new Button({
      title: 'Buscar',
      url: 'https://es.wikipedia.org/w/index.php?search=' + busqueda,
    }),
  }));
    
});  
//end buscar en wikipedia

//start juegos
app.intent('juego.menu(1.0)', (conv, {juego}) => {
  if (!conv.screen
      || !conv.surface.capabilities.has('actions.capability.WEB_BROWSER')) {
    conv.ask('Lo siento, prueba ésto en un dispositivo móvil ' +
             'o en un simulador en el navegador.');
    conv.ask('¿Qué te gustaría ver ahora?');
    return;
  }
  else{

conv.ask(`¡Qué bien!, pulsa en el botón para jugar`);
  conv.ask(new BasicCard({
    text: `Vale, jugaremos a ` + juego + ` pulsa el botón de abajo.`,
    subtitle: 'Haz click en el botón de abajo',
    title: 'Jugar',
    buttons: new Button({
      title: 'Jugar',
      url: 'https://www.google.com/search?q=' + juego + '&lr=lang_es',
    }),
  }));
  }
    
});  
//start buscar en wikipedia

// start chistes
app.intent('chiste.petición(1.0)', (conv) => {
  
  if (chisIteraciones <6)
  {
    chiste = shuffle(chiste);
    chisIteraciones++;
  }
  else 
  {
    chiste = shuffle([1,2,3,4,5,6]);
    chisIteraciones=0;
  }

  switch (chiste[chiste.length-1]){
    case 1:
      	conv.ask(
          		`-¿Qué le dijo la leche al café?` +
                `-¡Me estás poniendo negra!`);
        chiste.pop();
            break;
    case 2:
      conv.ask(
               `-¿Qué le dijo la bombilla al electricista?` +
               `-Te gusta hacerme la rosca.`);
        chiste.pop();
            break;
    case 3:
      conv.ask(
               `-¿Qué le dijo el trigo al molino?` +
               `-Me estás haciendo polvo.`);
        chiste.pop();
            break;
    case 4:

      conv.ask(
               `-¿Por qué los avestruces no tienen plumas en las patas?` +
               `-¡Porque corren que se las pelan!`);
        chiste.pop();
            break;
    case 5:

      conv.ask(
               `-¿Sabes cómo se queda un mago después de comer?` +
               `- Magordito`);
      chiste.pop();
      break;
    case 6:

      conv.ask(
               `-¿Cuál es la fruta más divertida?` +
               `-La naranjajajaja`);
      chiste.pop();
            break;
  }
  conv.ask(new Suggestions(['Cuéntame otro chiste']));
});
//end música

// [START df_js_media_response]
app.intent('musica.abrir(1.0)', (conv) => {
  if (!conv.surface.capabilities
    .has('actions.capability.MEDIA_RESPONSE_AUDIO')) {
      conv.ask('Lo siento, este dispositivo no soporta respuestas de audio');
      conv.ask('¿Qué otra cosa quieres hacer?');
      return;
  }
  
  if (musicaIteraciones <4)
  {
    musica = shuffle(musica);
    musicaIteraciones++;
  }
  else
  {
    musica = shuffle([0,1,2,3]);
    musicaIteraciones=0;
  }
  
  conv.ask('Aquí tenemos una canción, si quieres puedo buscar otra canción');
  switch (musica[musica.length-1]){
    case 0:
      	musica.pop();
        conv.ask(new MediaObject({
          name: '"Soy minero" de Antonio Molina',
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/Soy%20minero.mp3?alt=media&token=24ba484b-4d09-4b1a-af58-f8399732eda2',
          description: 'Canción de 1956',
          icon: new Image({
            url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/antonio%20molina.jpg?alt=media&token=80256525-6604-4187-afc5-75e8b5d9b3dc',
            alt: 'Una foto de Antiono Molina',
          }),
        }));
            break;
    case 1:
      musica.pop();
      conv.ask(new MediaObject({
          name: '"Clavelitos" de la Tuna de Derecho de Valladolid',
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/clavelitos-tuna-de-derecho-de-valladolid-2017.mp3?alt=media&token=2e6954f6-0ec0-4155-b087-4e05830bee81',
          description: 'Canción de 1949',
          icon: new Image({
            url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/tuna%20de%20derecho%20de%20valladolid.jpg?alt=media&token=024b5838-7472-4d10-a077-74de994c77b4',
            alt: 'una foto de su escudo',
          }),
        }));
            break;
    case 2:
      musica.pop();
      conv.ask(new MediaObject({
          name: '"Vallisoletana" de la Tuna de Derecho de Valladolid',
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/vallisoletana-tuna-de-derecho-valladolid.mp3?alt=media&token=dc3c8100-25e9-4e93-9b15-ad040403b4cd',
          description: 'Canción representada en 2013',
          icon: new Image({
            url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/tuna%20de%20derecho%20de%20valladolid.jpg?alt=media&token=024b5838-7472-4d10-a077-74de994c77b4',
            alt: 'Una foto de su escudo',
          }),
        }));
            break;
    case 3:
      musica.pop();
      conv.ask(new MediaObject({
          name: '"12 cascabeles" cantado por Joselito',
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/joselito-doce-cascabelesavi.mp3?alt=media&token=f972a593-24ef-436a-b418-e49877a12146',
          description: 'Canción de 1953',
          icon: new Image({
            url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/joselito.jpg?alt=media&token=e75cc82b-c197-42b3-9186-888eefaf7c1c',
            alt: 'Una foto de Joselito',
          }),
        }));
            break;
  }
  conv.ask(new Suggestions(['qué más canciones tienes']));
});
//end música

// start ejercicios
app.intent('ejercicios.inicio(1.0)', (conv) => {
  if (conv.screen && conv.surface.capabilities.has('actions.capability.WEB_BROWSER')) {
conv.ask(`Aquí tienes varios ejercicios, toca el que más te guste`);
  conv.ask(new BrowseCarousel({
    items: [
      new BrowseCarouselItem({
        title: 'Gimnasia general',
        url: 'https://www.youtube.com/watch?v=DYOTthcWj8g&list=PLE8t6HidiewFCtrcD-WUG4zYf4-Nn5cdG&index=6&t=0s',
        description: 'Ejercicios generales de gimnasia para mayores',
        image: new Image({
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/general%20icono.png?alt=media&token=7289305e-8ddc-489b-9111-b48e8ad53034',
        }),
        footer: 'ejercicios generales',
      }),
      new BrowseCarouselItem({
        title: 'Ejercicios para la parte inferior',
        url: 'https://www.youtube.com/watch?v=0mTU2g6SZuA&list=PLE8t6HidiewFCtrcD-WUG4zYf4-Nn5cdG&index=5&t=0s',
        description: 'Son ejercicios enfocados a la parte inferior del cuerpo',
        image: new Image({
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/piernas.png?alt=media&token=9d0a8f1d-f3f5-4e4a-b288-8dda80080789',
        }),
        footer: 'ejercicios de miembros inferiores',
      }),
      new BrowseCarouselItem({
        title: 'Ejercicios para la parte superior',
        url: 'https://www.youtube.com/watch?v=5qo70Fgq4mw&list=PLE8t6HidiewFCtrcD-WUG4zYf4-Nn5cdG&index=4&t=0s',
        description: 'Ejercicios para miembros superiores y tronco',
        image: new Image({
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/brazos.png?alt=media&token=1f395767-879a-4070-876c-9271b968ef6c',
        }),
        footer: 'ejercicios de la zona superior',
      }),
    ],
  }));
    return;
  }
  else{
    if (conv.surface.capabilities
    .has('actions.capability.MEDIA_RESPONSE_AUDIO')) {
      conv.ask(`Sería más sencillo de seguir en un dispositivo con navegador web, pero de todas formas aquí tienes`);
      conv.ask(new MediaObject({
          name: 'Ejercicios para todo el cuerpo',
          url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/ejercicios-para-personas-mayores-gimnasia-general-telegerontologia.mp3?alt=media&token=caddaf1b-363f-4614-a47e-e159dc24913e',
          description: 'Ejercicios generales',
          icon: new Image({
        	url: 'https://firebasestorage.googleapis.com/v0/b/test1-26d6c.appspot.com/o/general%20icono.png?alt=media&token=7289305e-8ddc-489b-9111-b48e8ad53034',
          }),
        }));
    	}
      else {
            conv.ask('Lo siento, prueba ésto en un dispositivo con ' +
            'sonido o navegador web');
            conv.ask('¿Qué te gustaría hacer ahora?');
      		}
        
  	}
  conv.ask(new Suggestions(['¿Qué mas puedes hacer?', 'Quiero escuchar una canción']));
});
// end ejercicios

//respuesta correcta facil
app.intent('adivinanzas.solución.fácil/correcto(1.0)', (conv) => {
  conv.ask('<speak>'+
    '<audio src="https://actions.google.com/sounds/v1/cartoon/cartoon_cowbell.ogg"></audio> '+
    '¡Respuesta correcta! también puedes pedirme que te cuente un chiste.'+
      '</speak>');
  }
);
//respuesta incorrecta facil
app.intent('adivinanzas.solución.fácil/incorrecto(1.0)', (conv) => {
  conv.ask('<speak>'+
    '<audio src="https://actions.google.com/sounds/v1/cartoon/cartoon_boing.ogg"></audio> '+
    '¡Respuesta incorrecta!'+
    'La respuesta correcta era caracol, también puedes pedirme que te cuente un chiste.'+
      '</speak>');
  }
);
//respuesta correcta dificil
app.intent('adivinanzas.solución.difícil/correcto(1.0)', (conv) => {
  conv.ask('<speak>'+
    '<audio src="https://actions.google.com/sounds/v1/cartoon/cartoon_cowbell.ogg"></audio> '+
    '¡Respuesta correcta! también puedes pedirme que te cuente un chiste.'+
      '</speak>');
  }
);
//respuesta incorrecta dificil
app.intent('adivinanzas.solución.difícil/incorrecto(1.0)', (conv) => {
  conv.ask('<speak>'+
    '<audio src="https://actions.google.com/sounds/v1/cartoon/cartoon_boing.ogg"></audio> '+
    '¡Respuesta incorrecta!'+
    'La respuesta correcta era huevo, también puedes pedirme que te cuente un chiste.'+
      '</speak>');
  }
);

// [START df_js_table_simple]
app.intent('medicinas.consulta(1.0)', (conv) => {
  if (!conv.screen) {
    conv.ask('lo siento, prueba ésto en un dispositivo con pantalla.');
    conv.ask('¿qué otra cosa quieres hacer?');
    return;
  }

  conv.ask('Aquí tienes tus medicinas,recuerda que si me lo pides puedo poner música.');
  conv.ask(new Table({
    dividers: true,
    columns: ['horario', 'medicinas'],
    rows: [
      ['desayuno', '1 pomada',],
      ['comida', '2 sobres y 1 pastilla'],
      ['cena', '1 pastilla'],
    ],
  }));
});
// [END df_js_table_simple]





//start charla.miNombre(1.0)
 app.intent('charla.miNombre(1.0)', (conv) => {
	
  if (login == `No`) {
    conv.ask(`Lo siento, aún no lo se`);
    conv.contexts.set('bienvenidalogin', 2, parameters);
  } else {
    conv.ask(`Te llamas ` + conv.data.nombre);
  }
 });
//end charla.miNombre(1.0)


//start charla.hora(1.0)
 app.intent('charla.hora(1.0)', (conv) => {

    conv.ask(`Son las ` + horaActual () +` y `+ minutoActual () + `.¿Qué más quieres hacer?`);

 });
//end charla.hora(1.0)

//start charla.dia(1.0)
 app.intent('charla.dia(1.0)', (conv) => {

    conv.ask(`Hoy es ` + fechaCumple(new Date())+`.¿Qué más quieres hacer?`);

 });
//end charla.dia(1.0)



exports.dialogflowFirebaseFulfillment = functions.https.onRequest(app);

//funciones varias


function saludo(conv){
  var texto = `  \n `; 
  if (8<=horaActual() && horaActual()<=14) texto = texto +  `¡Buenos días! `;
  else if (15<=horaActual() && horaActual()<=21) texto = texto + `¡Buenas tardes! `;
  else texto = texto + `¡Buenas noches! `;
  return texto;
}

function horaActual () {
  // Get current datetime with proper timezone
  let date = new Date();
  date.setHours(date.getHours() + parseInt(timeZoneOffset.split(':')[0]));
  date.setMinutes(date.getMinutes() + parseInt(timeZoneOffset.split(':')[0][0] + timeZoneOffset.split(':')[1]));

  return date.getHours() ;
}
function minutoActual () {
  // Get current datetime with proper timezone
  let date = new Date();
  date.setHours(date.getHours() + parseInt(timeZoneOffset.split(':')[0]));
  date.setMinutes(date.getMinutes() + parseInt(timeZoneOffset.split(':')[0][0] + timeZoneOffset.split(':')[1]));

  return date.getMinutes() ;
}

function bienvenidaMemoria(visitas,vecesHoy, nombre){
  var texto = `  \n `; 
  if (vecesHoy == 0) texto = texto +  `¡Buenas!, ¡no nos habíamos visto aún hoy! \n`;
  else if (vecesHoy > 0 && vecesHoy < 4) texto = texto + `¡Hola otra vez! \n`;
  else texto = texto + `Nos estamos viendo mucho hoy. ¡Qué bien! \n`;
  switch (visitas){
    case 1:
        texto = texto + `Aún nos conocemos poco, si quieres puedes pedirme que diga que puedo hacer` ;
        break;
    case 2:
        texto = texto + `¿Qué tal? Recuerda que te puedo ayudar para pedir cita para el médico` ;
        break;
    case 3:
        texto = texto + `¡Si estás con energías puedes decirme que te ayude a hacer ejercicio!` ;
        break;
    case 4:
        texto = texto + `¡Prueba a pedirme tus medicinas, a lo mejor te es útil! ` ;
        break;     
    case 5:
        texto = texto + `Cuando te apetezca ¡pídeme que recuerde tu cumpleaños! ` ;
        break; 
    case 6:
        texto = texto + `Ahora que nos conocemos un poco. ¿Quieres darme tu opinión sobre mí? ` ;
        break; 
    case 7:
      texto = texto + `Si te apetece puedo contarte un chiste o una adivinanza.` ;
      break; 
    case 8:
      texto = texto + `Para conocernos mejor aún, podrías decirme quien es tu cantante favorito.` ;
      break; 
    default:
		texto = texto + `¿Qué te apetece hacer `+ nombre + `?`;
        break;      
  }
  return texto;
}

function fecha(dia){

var dateObj = dia;
var month = dateObj.getUTCMonth() + 1; //months from 1-12
var day = dateObj.getUTCDate();
var year = dateObj.getUTCFullYear();

return  year + "/" + month + "/" + day;
  
}
function fechaCumple(dia){

var dateObj = dia;
var mes = dateObj.getUTCMonth() ; 
var day = dateObj.getUTCDate();
var month = new Array(12);
month[0] = 'Enero';
month[1] = 'Febrero';
month[2] = 'Marzo';
month[3] = 'Abril';
month[4] = 'Mayo';
month[5] = 'Junio';
month[6] = 'Julio';
month[7] = 'Agosto';
month[8] = 'Septiembre';
month[9] = 'Octubre';
month[10] = 'Noviembre';
month[11] = 'Dicembre';

return  day + ' de ' + month[mes];
  
}
function shuffle(array) {
  var currentIndex = array.length, temporaryValue, randomIndex;

  // While there remain elements to shuffle...
  while (0 !== currentIndex) {

    // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1;

    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}